%global lua_libdir %{_libdir}/lua/%{lua_version}
%global lua_pkgdir %{_datadir}/lua/%{lua_version}

%global lua_compat_version 5.1
%global lua_compat_libdir %{_libdir}/lua/%{lua_compat_version}
%global lua_compat_pkgdir %{_datadir}/lua/%{lua_compat_version}
%global lua_compat_builddir %{_builddir}/compat-lua-%{name}-%{version}-%{release}

%global libmpack_version 1.0.5

Summary:        Implementation of MessagePack for Lua
Name:           lua-mpack
Version:        1.0.11
Release:        2%{?dist}
License:        MIT
Url:            https://github.com/libmpack/libmpack-lua
Source0:        %{url}/archive/%{version}/libmpack-lua-%{version}.tar.gz
Source1:        https://github.com/libmpack/libmpack/archive/%{libmpack_version}/libmpack-%{libmpack_version}.tar.gz
Source2:        test_mpack.lua

BuildRequires:  libtool lua lua-devel

Requires:       lua(abi) = %{lua_version}

%description
mpack is a small binary serialization/RPC library that implements both the msgpack and
msgpack-rpc specifications.

%package -n lua5.1-mpack
Summary:        Implementation of MessagePack for Lua %{lua_compat_version}
BuildRequires:  compat-lua compat-lua-devel make
Requires:       lua(abi) = %{lua_compat_version}
Provides:       compat-%{name} = %{version}

%description -n lua5.1-mpack
mpack is a small binary serialization/RPC library that implements both the msgpack and
msgpack-rpc specifications for Lua %{lua_compat_version}.

%prep
%autosetup -p1 -n libmpack-lua-%{version}

mkdir mpack-src
pushd mpack-src
tar xfz %{SOURCE1} --strip-components=1
popd

echo '#!/bin/sh' > ./configure
chmod +x ./configure

rm -rf %{lua_compat_builddir}
cp -a . %{lua_compat_builddir}

%build
%configure
%make_build \
    USE_SYSTEM_MPACK=no \
    USE_SYSTEM_LUA=yes \
    MPACK_LUA_VERSION=%{lua_version}.x \
    LUA_INCLUDE="$(pkg-config --cflags lua)" \
    %{nil}

pushd %{lua_compat_builddir}
%configure
%make_build \
    USE_SYSTEM_MPACK=no \
    USE_SYSTEM_LUA=yes \
    MPACK_LUA_VERSION=%{lua_compat_version}.x \
    LUA_INCLUDE="$(pkg-config --cflags lua-%{lua_compat_version})" \
    %{nil}
popd

%install
make \
    USE_SYSTEM_MPACK=no \
    USE_SYSTEM_LUA=yes \
    LUA_CMOD_INSTALLDIR=%{lua_libdir} \
    DESTDIR=%{buildroot} \
    install

pushd %{lua_compat_builddir}
make \
    USE_SYSTEM_MPACK=no \
    USE_SYSTEM_LUA=yes \
    LUA_CMOD_INSTALLDIR=%{lua_compat_libdir} \
    DESTDIR=%{buildroot} \
    install
popd

%check
lua %{SOURCE2}

%files
%doc README.md
%{lua_libdir}/mpack.so

%files -n lua5.1-mpack
%{lua_compat_libdir}/mpack.so

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0.11-2
- Rebuilt for loongarch release

* Wed Jan 03 2024 Upgrade Robot <upbot@opencloudos.org> - 1.0.11-1
- Upgrade to version 1.0.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0.9-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0.9-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0.9-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Jan 16 2023 Shuo Wang <abushwang@tencent.com> - 1.0.9-1
- initial build
